/*************************************************************************
*
*
*	Name:		proctab.c
*
*	Description:	Procedure/function argument list
*
*	History:
*	Date		By	Comments
*
*	09/01/83	jle
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright 1983 by Technical Analysis Corporation.
*
*************************************************************************
* BB/Xenix Compiler Module */




/*  Notes -

*/

#include "tokens.h"
#include "opcodes.h"
#include "vartab.h"
#include "proctab.h"
struct PROCTAB functab[]=
{
	TABS,	typeL,	ABSL,	"l",
	TAND,	typeL,	ANDL,	"ll",
	TASC,	typeL,	ASCL,	"a",
	TEOF,   typeJ,  EOFJ,   "j",
	TGPOS,  typeL,  GPOSL,  "j",
      	TLEN,	typeJ,	LENJ,	"a",
	TMAX,   typeL,  MAXL,   "ll",
	TMIN,   typeL,  MINL,   "ll",
	TMOD,   typeL,  MODL,   "ll",
	TOR,    typeL,  ORL,    "ll",
	TPOS,	typeJ,	POSJ,	"aa/=1jj",
	TRND,   typeL,  RNDL,   "l",
	TSGN,   typeJ,  SGNL,   "l",
	TSHFT,  typeL,  SHFL,   "lj",
	TSQR,   typeL,  SQRL,   "l",
	TSYS,	typeL,	SYSL,	"j",
	TVAL,	typeL,	VALL,	"a#",
/* string functions */
	TCHR,	typeA,	CHRL,	"l/=1j",
	TCRM,	typeA,	CRM,	"a",
	TERM,	typeA,	ERM,	"l",
	TFILL,	typeA,	FILL,	"j/=32767j",
	TTRUN,	typeA,	TRUN,	"a/=0j",
	TUCM,	typeA,	UCM,	"a",
};

struct PROCTAB proctab[]=
{
	TDELAY,	0,	DELAY,	"j",
	TDELREC,0,	DELREC,	"jl",
	TXTRACT,0,	EXTRACT,"$aa#",
	TGETREC,0,	GETREC,	"j#",
	TKADD,	0,	KADDL,	"j$$#",
	TKADD,	1,	KADDS,	"a$$#",
	TKDEL,	0,	KDELL,	"j$$#",
	TKDEL,	1,	KDELS,	"a$$#",
	TKFIND,	0,	KFNDL,	"j$$#",
	TKFIND,	1,	KFNDS,	"a$$#",
	TKNEXT,	0,	KNXTL,	"j$$#",
	TKNEXT,	1,	KNXTS,	"a$$#",
	TLOCK,	0,	LOCKL,	"jl/#",	/* first arg not shown */
	TLOCK,	1,	LOCKS,	"all/#",/* first arg not shown */
	TQADD,	0,	QADD,	"$aa",
	TQDIV,	0,	QDIV,	"#al/##",
	TQLOAD,	0,	QLOAD,	"$l",
	TQMUL,	0,	QMUL,	"$ll",
	TQSTORE,0,	QSTORE,	"#a",
	TQSUB,	0,	QSUB,	"$aa",
	TREPLACE,0,	PREPLACE,"a",
	TSAVE,	0,	PSAVE,	"a",
	TSWHILE,0,	SWHILE,	"#aa/=1j",
	TSUNTIL,0,	SUNTIL,	"#aa/=1j",
	TSYSTEM,0,	SYSTEM,	"#a",
	TSTMA,	1,	STMA1,	"j#",
	TSTMA,	2,	STMA2,	"jj",
	TSTMA,	3,	STMA3,	"j#",
	TSTMA,	4,	STMA4,	"jj",
	TSTMA,	5,	STMA5,	"j#",
	TSTMA,	6,	STMA6,	"j",
	TSTMA,	7,	STMA7,	"j",
	TSTMA,	8,	STMA8,	"j",
	TSTMA,	9,	STMA9,	"j$",
	TSTMA,	10,	STMA10,	"ja",
	TSTMA,	11,	STMA11,	"l###",
	TSTMA,	12,	STMA12,	"#jjj",
	TSTMA,	13,	STMA13,	"$a",
	TSTMA,	14,	STMA14,	"$j",
	TSTMA,	15,	STMA15,	"aa#",
	TSTMA,	19,	STMA19,	"l",
	TSTMA,	20,	STMA20,	"/=-1j",
	TSTMA,	21,	STMA21,	"aj##/###",
	TSTMC,	0,	STMC0,	"#al",
	TSTMC,	1,	STMC1,	"#a",
	TSTMC,	5,	STMC5,	"#al",
	TSTMC,	6,	STMC6,	"#a",
	TSTMC,	7,	STMC7,	"#a",
	TSTMC,	8,	STMC8,	"#a",
	TSTMC,	9,	STMC9,	"#a",
	TSTMC,	11,	STMC11,	"#j",
	TSTMC,	17,	STMC17,	"#$",
	TSTMC,	21,	STMC21,	"#aa",
	TSTMC,	22,	STMC22,	"#$",
	TSTMC,	23,	STMC23,	"#",
	TSTMC,	24,	STMC24,	"#",
	TSTMC,	25,	STMC25,	"#aa",
	TSTMC,	28,	STMC28,	"#",
	TSTMC,	29,	STMC29,	"#jjj",
	TSTMC,	34,	STMC34,	"#jjj",
	TSTMC,	35,	STMC35,	"#a",
	TSTMC,	36,	STMC36,	"#j",
	TSTMC,	39,	STMC39,	"#ajj",
	TSTMC,	40,	STMC40,	"#ajj",
	TSTMC,	41,	STMC41,	"#ajj",
	TSTMC,	42,	STMC42,	"#ajj",
	TSTMC,	43,	STMC43,	"#",
	TSTMC,	44,	STMC44,	"#ajj",
	TSTMC,	45,	STMC45,	"#ala",
	TSTMC,	46,	STMC46,	"#aa",
	TSTMC,	47,	STMC47,	"#aa",
	TSTMC,	52,	STMC52,	"#al",
	TSTRPOS,0,	STRPOS,	"#aa/=1jj",
	TUNLOCK,0,	UNLOCK,	"/j",
	TVALUE,	0,	VALUE,	"#a/##",
	TXCALL,	7,	STMA21,	"aj##/###",
	TXCALL,	11,	XCAL11,	"$$j",
      	TXCALL,	12,	SWHILE,	"#aa/=1j",
	TXCALL,	13,	SUNTIL,	"#aa/=1j",
	TXCALL,	14,	EXTRACT,"$aa#",
        TXCALL,	15,	XCAL15,	"$jj",
	TXCALL,	16,	XCAL16,	"$j",
};
