/*************************************************************************
*
*
*	Name:  bberms.h
*
*	Description:  BB error codes.
*
*
*	History:
*	Date		By		Comments
*
*	11/8/83		waf		Rem'ed out unused codes to reduce the number of
*					#define's.
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright (c) 1983 by Technical Analysis Corporation.
*
*************************************************************************
* BB/Xenix Runtime Module */




/*  Notes -

.SH*/

/* Business BASIC error codes */

#define	NOERR	000000		/* Specal 'no error' error */
#define	NOERC	000001		/* Specal 'no error' error for STMCs */
/*		BECHR	000001		/* Illegal character */
#define	BESYN	000002		/* Statement or command syntax is invalid */
#define	BERDT	000003		/* READ/DATA types inconsistent */
#define	BESYS	000004		/* SYSTEM (program is lost) */
#define	BESTN	000005		/* Statement number */
/*		BETMV	000006		/* Excessive number of variables (more than 348) */
/*		BECOM	000007		/* Statement may not be used as a command */
/*		BESPE	000010		/* Specification */
/*		BEIRF	000011		/* Illegal reserved file name */
/*		BEFIU	000012		/* Reserved file in use */
#define	BEPRN	000013		/* Parenthesis */
/*		BEICM	000014		/* Illegal command */
#define	BENLN	000015		/* Line number */
/*		BEPRM	000016		/* No more program memory */
#define	BEEOD	000017		/* End of DATA */
#define	BEARI	000020		/* Arithmetic */
/*		BEUAV	000021		/* Unassigned variable */
#define	BEGSN	000022		/* GOSUB nesting */
#define	BERNG	000023		/* RETURN - no GOSUB */
#define	BEFRN	000024		/* FOR nesting */
/*		BEFNN	000025		/* FOR - no NEXT */
#define	BENNF	000026		/* NEXT - no FOR */
#define	BEDTM	000027		/* No more data memory */
#define	BENAC	000030		/* No available channels */
#define	BEOPT	000031		/* Option is not in this system */
/*		BENAM	000032		/* Program/data overflow */
#define	BEIFN	000033		/* Illegal file number */
#define	BEDIM	000034		/* New dimension exceeds old dimension */
/*		BEEXP	000035		/* Expression */
#define	BEMOD	000036		/* Illegal mode */
#define	BESUB	000037		/* Subscript */
#define	BEUDF	000040		/* Undefined function */
#define	BEFUN	000041		/* Function nesting */
#define	BEFAR	000042		/* Function argument */
#define	BEIFS	000043		/* Illegal format string */
#define	BESSZ	000044		/* String size */
/*		BEUSR	000045		/* User routine */
#define	BEUDS	000046		/* Undimensioned string */
/*		BEDMT	000047		/* Duplicate matrix */
/*		BEMSZ	000050		/* Matrices sizes */
/*		BEMDM	000051		/* Matrix DIM */
#define	BEFAO	000052		/* File already opened */
/*		BEMNS	000053		/* Matrix not square */
#define	BEFNO	000054		/* File unopened */
#define	BEIRL	000055		/* Illegal record length */
#define	BEIIN	000056		/* Input invalid */
#define	BEWRM	000057		/* Wrong mode */
#define	BENSV	000060		/* Not a save file */
/*		BENRD	000061		/* No room for directory */
/*		BEIOC	000062		/* Invalid operator command */
/*		BEUNO	000063		/* User not on system */
/*		BEUNM	000064		/* User in NOMSG state */
/*		BERNE	000065		/* Renumbering error(s) */
/*		BESTL	000066		/* Statement length */
#define	BEBIO	000067		/* Block I/O error */
#define	BEDLK	000070		/* Attempt to LOCK same area twice */
#define	BERIU	000071		/* Data base record is LOCKed */
#define	BEISF	000072		/* Incompatible save file */
#define	BEZST	000073		/* Zero STEP */
#define	BELTL	000074		/* Line too long */
/*		BEMRP	000075		/* Missing right parenthesis in format */
#define	BERUN	000076		/* Save file is run only */
/*		BEARN	000077		/* Incorrect number of arguments */
/*		BEART	000100		/* Incorrect argument type */
#define	BESWP	000101		/* Program swapping error */
#define	BESAR	000102		/* String argument in error */
#define	BENDX	000103		/* Error in index file or index parameters */
#define	BEIFF	000104		/* Index file full */
/*		BEIPB	000105		/* Excessive IPB errors */
#define	BEIJN	000106		/* Invalid job/terminal number */
/*		BEJAA	000107		/* Job/terminal already attached */
/*		BEJNI	000110		/* Job is not waiting on input */
/*		BEEBE	000111		/* Edit buffer is empty */
/*		BEPNL	000113		/* Program may not be listed */
#define	BENDF	000114		/* Not a data base file */
#define	BEIRN	000115		/* Illegal record number */
#define	BELSE	000116		/* LFTABL$ string error */
#define	BEIFT	000117		/* Illegal file type */
#define	BELFN	000120		/* Logical file does not exist */
#define	BEIRS	000121		/* Illegal record status */
/*		BEDFF	000122		/* Data file full */
/*		BEIDN	000123		/* Illegal or duplicate name */
/*		BEDDE	000124		/* Data dictionary error */
/*		BENAN	000125		/* No available logical file numbers */
/*		BEFOR	000126		/* Logical file number out of range */
/*		BENEL	000127		/* Missing ELSE or END IF */
/*		BEEEL	000130		/* Extra ELSE or missing END IF */
#define	BELTF	000131		/* LOCK table full */


/* the following errors are utility messages and are not used by bb */

/*		BEIOF	000200     Invalid or out-of-range field */
/*		BENKY	000201     No key was given */
/*		BERNX	000202     Record does not exist */
/*		BERAE	000203     Record already exists */
/*		BEVER	000204     Validation error. key was changed */
/*		BEFIF	000205     Function is invalid without a FIND function first */
/*		BECFE	000206     Control file is in error */
/*		BEIFP	000207     Invalid format or page */
/*		BENNR	000210     No next record */
/*		BEIXM	000211     Index for this record may be all messed up */
/*		BEKND	000212     Key could not be deleted */
/*		BERNC	000213     Request not completed */
/*		BEIAP	000214     Invalid account/password */
/*		BEITO	000215     INPUT timed out */
/*		BEDAN	000216     Device is assigned, but not to you */
/*		BEILF	000217     Illegal function */
/*		BEFNF	000220     File not found */
/*		BEKAD	000222     Key already exists and duplicates not allowed */
/*		BEISL	000223     Insufficient space for logical file */
/*		BEFSB	000224     File not on sector boundary */
/*		BEROS	000225     Record out of sequence */
/*		BEIBF	000226     Illegal blocking factor */
/*		BEIKL	000227     Illegal key length */
/*		BEDDN	000230     Data dictionary does not exist */
/*		BEFTM	000231     File types do not match */
/*		BEWPG	000232     Wrong program */
