/*************************************************************************
*
*
*	Name:  pcondcomp.h
*
*	Description:  Contains the conditional compilation defines for the 
*		      p-machine
*
*
*	History:
*	Date		By	Comments
*
*	05/23/83	mas
*	07/21/83	mas	added define to control whether locking
*						is actually done. This is for the XENIX
*						locking (RLOCK) bug
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright 1983 by Technical Analysis Corporation.
*
*************************************************************************
* BB/Xenix Runtime Module */




/*  Notes -

*/


/* 
	Conditional compile define for the stack and register dumps after
	each p-code is executed
*/
/* #define DEBDEF 1 */

/*
	Define to cause a p-code histogram to be created
*/
/* #define PHIST 1 */

#ifdef	PHIST
	/* define type of histogram to be produced */
#define	PCODESW	FALSE	/* if set, record p-code frequency */
#define	PCSW	TRUE	/* if set, record pc frequency */
#if	PCODESW && PCSW
	>> Can not have PCODESW and PCSW both set
#endif
#endif

/*
	Define to control overflow checking in pmach.c
*/
#define OVERFLOW 1

/*
	Define to control locking system calls 
	Should be defined until the RLOCK problem is fixed in XENIX
*/
/* #define NOLOCKING 1 */
