/*************************************************************************
*
*
*	Name:  syerms.h
*
*	Description:  System error codes param file.
*
*
*	History:
*	Date		By		Comments
*
*				mas
*	11/11/83	waf		Rem'ed out unused codes (to reduce # of define's).
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright (c) 1983 by Technical Analysis Corporation.
*
*************************************************************************
* BB/Xenix Runtime Module */




/*  Notes -

.SH*/


/* System error codes */
				
#define	ERFNO	000000      /* Illegal channel number */	
#define	ERFNM	(-000001)     /* Illegal file name */	
#define	ERICM	(-000002)     /* Illegal system command */	
#define	ERICD	(-000003)     /* Illegal command for device */	
/*		ERSV1	(-000004)     /* Not a saved file */	
#define	ERWR0	(-000005)     /* Attempt to write an existent file */	
#define	EREOF	(-000006)     /* End of file */	
/*		ERRPR	(-000007)     /* Attempt to read a read protected file */	
#define	ERWPR	(-000010)     /* Write protected file */	
#define	ERCRE	(-000011)     /* Attempt to create an existent file */	
#define	ERDLE	(-000012)     /* A non-existent file */	
/*		ERDE1	(-000013)     /* Attempt to alter a permanent file */	
#define	ERCHA	(-000014)     /* Attributes protected */	
/*		ERFOP	(-000015)     /* File not opened */	
/*		ERFUE	(-000016)     /* Fatal utility error */	
/*		EREXQ	(-000017)     /* Execute CLI.CM (no error) */	
#define	ERNUL	(-000020)     /* Invisible error code */	
#define	ERUFT	(-000021)     /* Attempt to use a UFT already in use */	
/*		ERLLI	(-000022)     /* Line limit exceeded */	
/*		ERRTN	(-000023)     /* Attempt to restore a non-existent image */	
/*		ERPAR	(-000024)     /* Parity error on read line */	
/*		ERCM3	(-000025)     /* Trying to push too many levels */	
#define	ERMEM	(-000026)     /* Not enough memory available */	
#define	ERSPC	(-000027)     /* Out of file space */	
#define	ERFIL	(-000030)     /* File read error */	
/*		ERSEL	(-000031)     /* Unit not properly selected */	
#define	ERADR	(-000032)     /* Illegal starting address */	
/*		ERRD 	(-000033)     /* Attempt to read into system area */	
#define	ERDIO	(-000034)     /* File accessible by direct I/O only */	
/*		ERDIR	(-000035)     /* Files specified on diff. directories */	
#define	ERDNM	(-000036)     /* Device not in system */	
/*		EROVN	(-000037)     /* Illegal overlay number */	
/*		EROVA	(-000040)     /* File not accessible by direct I/O */	
#define	ERTIM	(-000041)     /* User set time error */	
#define	ERNOT	(-000042)     /* Out of TCB's */	
/*		ERXMT	(-000043)     /* Signal to busy addr */	
/*		ERSQF	(-000044)     /* File already squashed error */	
/*		ERIBS	(-000045)     /* Device already in system */	
/*		ERICB	(-000046)     /* Insufficent contiguous blocks */	
/*		ERSIM	(-000047)     /* Simultaneous read or write to mux line */	
/*		ERQTS	(-000050)     /* Error in user task queue table */	
/*		ERNMD	(-000051)     /* No more dcb's */	
#define	ERIDS	(-000052)     /* Illegal directory specifier */	
#define	ERDSN	(-000053)     /* Directory specifier not known */	
/*		ERD2S	(-000054)     /* Directory is too small */	
/*		ERDDE	(-000055)     /* Directory depth exceeded */	
/*		ERDIU	(-000056)     /* Directory in use */	
#define	ERLDE	(-000057)     /* Link depth exceeded */	
#define	ERFIU	(-000060)     /* File is in use */	
#define	ERTID	(-000061)     /* Task id error */	
/*		ERCMS	(-000062)     /* Common size error */	
/*		ERCUS	(-000063)     /* Common usage error */	
#define	ERSCP	(-000064)     /* File position error */	
/*		ERDCH	(-000065)     /* Insufficient room in data channel map */	
/*		ERDNI	(-000066)     /* Directory not initialized */	
/*		ERNDD	(-000067)     /* No default directory */	
/*		ERFGE	(-000070)     /* Foreground alreadys exists */	
/*		ERMPT	(-000071)     /* Error in partiton set */	
/*		EROPD	(-000072)     /* Directory in use by other program */	
#define	ERUSZ	(-000073)     /* No room for UFTs on EXEC/EXFG */	
/*		ERMPR	(-000074)     /* Address error on .SYSTM param */	
#define	ERNLE	(-000075)     /* Not a link entry */	
/*		ERNTE	(-000076)     /* Current BG is not checkpointable */	
#define	ERSDE	(-000077)     /* SYS.DR error */	
/*		ERMDE	(-000100)     /* MAP.DR error */	
/*		ERDTO	(-000101)     /* Device time out */	
#define	ERENA	(-000102)     /* Entry not accessible via link */	
/*		ERMCA	(-000103)     /* MCA request outstanding */	
/*		ERSRR	(-000104)     /* Incomplete transmission caused by reciever */	
#define	ERSDL	(-000105)     /* System deadlock */	
/*		ERCLO	(-000106)     /* I/O terminated by channel close */	
/*		ERSFA	(-000107)     /* Spool file(s) active */	
#define	ERABT	(-000110)     /* Task not found for abort */	
#define	ERDOP	(-000111)     /* Device previously opened */	
/*		EROVF	(-000112)     /* System stack overflow */	
/*		ERNMC	(-000113)     /* No MCA receive request outstanding */	
/*		ERNIR	(-000114)     /* No init/release on opened device (mag tape) */	
/*		ERXMZ	(-000115)     /* .XMT & .IXMT messages must be non-zero */	
#define	ERCAN	(-000116)     /* 'you can't do that' */	
/*		ERQOV	(-000117)     /* .TOVLD not loaded for queued overlay tasks */	
/*		EROPM	(-000120)     /* Operator message module not sysgened */	
/*		ERFMT	(-000121)     /* Disk format error */	
/*		ERBAD	(-000122)     /* Disk has invalid bad block table */	
/*		ERBSP	(-000123)     /* Insufficient space in bad block pool (core) */	
/*		ERZCB	(-000124)     /* Attempt to create contig of zero length */	
/*		ERNSE	(-000125)     /* Program is not swappable */	
/*		ERBLT	(-000126)     /* Blank tape */	
/*		ERRDY	(-000127)     /* Line not ready */	
#define	ERINT	(-000130)     /* Console interrupt received */	
/*		EROVR	(-000131)     /* Character over run error */	
/*		ERFRM	(-000132)     /* Character framing error */	
/*		ERSPT	(-000133)     /* Too many soft errors (DOS only) */	
/*		ERSOF	(-000134)     /* QTY buffer overflow */	


/* CLI error codes */

/*		CNEAR	(-000300)     /* Not enough arguments */
/*		CILAT	(-000301)     /* Illegal attribute */
/*		CNDBD	(-000302)     /* No debug address */
/*		CCLTL	(-000303)     /* Command line too long */
/*		CNSAD	(-000304)     /* No starting address */
/*		CCKER	(-000305)     /* Checksum error */	
/*		CNSFS	(-000306)     /* No source file specified */
/*		CNACM	(-000307)     /* Not a command */
/*		CILBK	(-000310)     /* Illegal block type */
/*		CSPER	(-000311)     /* No files match specifier */	
/*		CPHER	(-000312)     /* Phase error */	
#define	CTMAR	(-000313)     /* Too many arguments */
/*		CTMAD	(-000314)     /* Too many active devices */
/*		CILNA	(-000315)     /* Illegal numeric argument */
/*		CSFUE	(-000316)     /* Fatal system utility error */
#define	CILAR	(-000317)     /* Illegal argument */
/*		CCANT	(-000320)     /* Improper or malicious input */
/*		CTMLI	(-000321)     /* Too many levels of indirect files */
/*		CSYER	(-000322)     /* Syntax error */	
/*		CBKER	(-000323)     /* Bracket error */	
/*		CPARE	(-000324)     /* Paren error */
/*		CCART	(-000325)     /* < without > or > without < */
/*		CCAR1	(-000326)     /* Illegal nesting of <> and () */
/*		CINDE	(-000327)     /* Illegal indirect filename */
/*		CPAR1	(-000330)     /* Illegal nesting of () and {} */
/*		CIVAR	(-000331)     /* Illegal variable */
/*		CILTA	(-000332)     /* Illegal text argument */
/*		CTATL	(-000333)     /* Text argument too long */
