During character device input/output, Xenix handles interrupts in a manner
which is different from the way interrupts are normally handled. This
philisophical difference in interrupt handling can make a difference in the
way a BB program will function when the user hits the ikey during "char i/o".


The Xenix philosophy of ikey handling during char i/o is described in "Unix
Programmer's Manual", Vol. 2a, "Unix Programming" section, page 16.


It is important that the BB user (and programmer) understand the functional
differences in interrupt handling, and what "char i/o" is.


"Character i/o" includes i/o to 'character oriented devices' such as terminals
and printers, as well as i/o using 'pipes'. Note that BB/U allows the use of
pipes via OPEN modes 12 & 13. The programmer should be sure to recognize all
'files' which the XENIX system has defined as 'character devices'.


Functionally, char i/o ikey handling will make a difference in two ways -

1) When an ikey occurs during char i/o, the i/o (system) call is ABORTED.
