/*************************************************************************
*
*
*	Name:  bsystem.c
*
*	Description:  performs SYSTEM p-code function
*
*
*	History:
*	Date		By	Comments
*
*	05/06/83	mas
*	7/22/83		waf	Added conditional code for BB/PC.
*						SYSTEM statement not implemented for BB/PC.
*						Calling bsystem() causes BEOPT error.
*	08/11/83	waf	Allow command line length of 512.
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright 1983, 1984 by Digital Communications Assoc.
*
*************************************************************************
* BB/Xenix Runtime Module */




/*  Notes -

* Note *
  If there is an error in the system() call, an error code of '127' is
  returned.

/*
.SH*/

#include "/bb/include/ptype.h"
#include "/bb/include/pextern.h"

#define	BUFSIZE	512		/* size of cmd buffer */


bsystem(err,command)
NUMDES	err;
STRDES	command;
{
	char	buf[BUFSIZE+1];		/* command buffer */


#if	BB_PC		/* SYSTEM stmt not implemented for BB/PC */

	bberr( BEOPT );

#endif


#if	BB_X86	/* SYSTEM stmt is specific to BB/X86 */

	movdb(&command,buf,BUFSIZE);

	errchk(&err,system(buf));

	return;

#endif

}
