/*************************************************************************
*
*
*	Name:  errxtbl.c
*
*	Description:
*			Error number translate table.
*			Translates system specific errors to RDOS equivalent.
*
*
*	History:
*	Date		By	Comments
*
*	03/01/83	mas
*	07/22/83	waf	Added extblsiz global var = size of errxtbl.
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright 1983, 1984 by Digital Communications Assoc.
*
*************************************************************************
* BB/Xenix Runtime Module */




/*  Notes -

7/22/83	waf -
	The MSDOS system specific functions return Xenix error codes, so no
	special translation of MSDOS error codes is necessary.


.SH*/

#include	"/bb/include/pdefine.h"
#include "/bb/include/syerms.h"
#include "/bb/include/bberms.h"


int	errxtbl[] = {
	ERNUL,	/* 0  */
	ERCAN,	/* 1  */
	ERDLE,	/* 2  */
	ERTID,	/* 3  */
	ERINT,	/* 4  */
	ERFIL,	/* 5  */
	ERDNM,	/* 6  */
	CTMAR,	/* 7  */
	ERICM,	/* 8  */
	ERUFT,	/* 9  */
	ERABT,	/* 10 */
	ERNOT,	/* 11 */
	ERMEM,	/* 12 */
	ERCHA,	/* 13 */
	ERADR,	/* 14 */
	ERDIO,	/* 15 */
	ERDOP,	/* 16 */
	ERWR0,	/* 17 */
	ERENA,	/* 18 */
	ERDNM,	/* 19 */
	ERDSN,	/* 20 */
	ERIDS,	/* 21 */
	CILAR,	/* 22 */
	ERUSZ,	/* 23 */
	ERUSZ,	/* 24 */
	ERICD,	/* 25 */
	ERFIU,	/* 26 */
	ERSCP,	/* 27 */
	ERSPC,	/* 28 */
	ERSCP,	/* 29 */
	ERWPR,	/* 30 */
	ERLDE,	/* 31 */
	ERNUL,	/* 32 */
	BEFAR,	/* 33 */
	BEARI,	/* 34 */
	ERSDE,	/* 35 */
	ERSDL };	/* 36 */

int	extblsiz	= 36 ;	/* 36 entries in Xenix error table */
