%OVERLAY TO "TESTDRIV.bp"
0001 LET X=0
0030 ON ERR THEN GOTO 9000
0040 ON IKEY THEN GOTO 9000
0050 DIM TEST$[50],PASS$[16],STR$[20]
0060 LET PASS$="PASSED"
0070 LET TEST$="PACK STATEMENT TEST - NUMERIC RANGE CHECK"
0080 LET TOTIME=0
0100 DIM STR1$[80],STR2$[80],TYPE$[80],PRLN$[132]
0110 LET ERRCNT=0
0200 LET TYPE$="MAXIMUM UNSIGNED VALUES"
0205 LET A=255 \ B=65535 \ C=16777215
0210 LET STR1$=CHR$(A,1),CHR$(B,2),CHR$(C,3),FILL$(0)
0215 PACK "ZBCD",STR2$,A,B,C
0220 IF STR1$<>STR2$ THEN GOSUB 2000 :  ERROR REPORT
0225 LET TYPE$="MAXIMUM SIGNED VALUES"
0230 LET A=127 \ B=32767 \ C=8388607 \ D=2147483647
0235 LET STR1$=CHR$(A,1),CHR$(B,2),CHR$(C,3),CHR$(D,4)
0240 LET STR1$[0]=CHR$(-A,1),CHR$(-B,2),CHR$(-C,3),CHR$(-D,4),FILL$(0)
0245 PACK "ZIJKLIJKL",STR2$,A,B,C,D,-A,-B,-C,-D
0250 IF STR1$<>STR2$ THEN GOSUB 2000 :  ERROR REPORT
0255 ON ERR THEN GOTO 0280
0260 LET TYPE$="1-BYTE UNSIGNED OVERFLOW ERROR"
0265 PACK "ZB",STR1$,256
0270 ON ERR THEN GOTO 9000
0275 GOSUB 2500 :  NO-ERROR ERROR REPORT
0280 ON ERR THEN GOTO 0305
0285 LET TYPE$="2-BYTE UNSIGNED OVERFLOW ERROR"
0290 PACK "ZC",STR1$,65536
0295 ON ERR THEN GOTO 9000
0300 GOSUB 2500 :  NO-ERROR ERROR REPORT
0305 ON ERR THEN GOTO 0330
0310 LET TYPE$="3-BYTE UNSIGNED OVERFLOW ERROR"
0315 PACK "ZD",STR1$,16777216
0320 ON ERR THEN GOTO 9000
0325 GOSUB 2500 :  NO-ERROR ERROR REPORT
0330 ON ERR THEN GOTO 0355
0335 LET TYPE$="1-BYTE SIGNED OVERFLOW ERROR"
0340 PACK "ZI",STR1$,128
0345 ON ERR THEN GOTO 9000
0350 GOSUB 2500 :  NO-ERROR ERROR REPORT
0355 ON ERR THEN GOTO 0380
0360 LET TYPE$="2-BYTE SIGNED OVERFLOW ERROR"
0365 PACK "ZJ",STR1$,32768
0370 ON ERR THEN GOTO 9000
0375 GOSUB 2500 :  NO-ERROR ERROR REPORT
0380 ON ERR THEN GOTO 0405
0385 LET TYPE$="3-BYTE SIGNED OVERFLOW ERROR"
0390 PACK "ZK",STR1$,8388608
0395 ON ERR THEN GOTO 9000
0400 GOSUB 2500 :  NO-ERROR ERROR REPORT
0405 ON ERR THEN GOTO 0430
0410 LET TYPE$="1-BYTE SIGNED OVERFLOW ERROR"
0415 PACK "ZI",STR1$,-129
0420 ON ERR THEN GOTO 9000
0425 GOSUB 2500 :  NO-ERROR ERROR REPORT
0430 ON ERR THEN GOTO 0455
0435 LET TYPE$="2-BYTE SIGNED OVERFLOW ERROR"
0440 PACK "ZJ",STR1$,-32769
0445 ON ERR THEN GOTO 9000
0450 GOSUB 2500 :  NO-ERROR ERROR REPORT
0455 ON ERR THEN GOTO 0480
0460 LET TYPE$="3-BYTE SIGNED OVERFLOW ERROR"
0465 PACK "ZK",STR1$,-8388609
0470 ON ERR THEN GOTO 9000
0475 GOSUB 2500 :  NO-ERROR ERROR REPORT
0480 ON ERR THEN GOTO 9000
0485 IF ERRCNT=0 THEN GOTO 9900
0600 REM IN CASE OF FAILURE
0610 PRINT FILE[1],
0620 PRINT FILE[1],"  ***  ";ERRCNT;"ERRORS   ***"
0630 CLOSE FILE[1]
0640 LET PASS$="*****FAILED*****"
0650 GOTO 9900
2000 REM ERROR REPORT
2010 IF ERRCNT=0 THEN GOSUB 6000 :   PRINT TEST-FAILURE
2020 LET ERRCNT=ERRCNT+1
2030 PRINT FILE[1], TAB(8);TYPE$
2040 LET PRLN$="UNEQUAL LENGTHS: STR1$ HAS "
2050 LET PRLN$[0]=LEN(STR1$)," AND STR2$ HAS ",LEN(STR2$)
2060 IF LEN(STR1$)<>LEN(STR2$) THEN PRINT FILE[1], TAB(16);PRLN$
2070 IF LEN(STR1$)<>LEN(STR2$) THEN RETURN 
2080 PRINT FILE[1], TAB(16);"STRINGS DO NOT MATCH"
2090 RETURN 
2500 REM NO-ERROR ERROR REPORT
2510 IF ERRCNT=0 THEN GOSUB 6000 :   PRINT TEST-FAILURE
2520 LET ERRCNT=ERRCNT+1
2530 PRINT FILE[1], TAB(8);TYPE$
2540 LET PRLN$="ILLEGAL VALUE DID NOT CAUSE OVERFLOW"
2550 PRINT FILE[1], TAB(16);PRLN$
2560 RETURN 
6000 REM  PRINT TEST-FAILURE
6001 DIM PROGM$[20],TST$[20]
6002 STMA 9,2,PROGM$
6003 STMA 6,5
6004 LET TST$=TRUN$(PROGM$),".OUT"
6005 OPEN FILE[1,1],TST$
6010 PRINT FILE[1]
6020 PRINT FILE[1]
6030 PRINT FILE[1],TEST$
6040 PRINT FILE[1]
6050 PRINT FILE[1],"  TEST FAILED UNDER THE  FOLLOWING  CONDITIONS:"
6060 PRINT FILE[1]
6070 RETURN 
6200 REM PRINT TEST-RESULTS
6203 STMA 6,5
6205 DIM PROG$[20]
6207 STMA 9,2,PROG$
6210 PRINT FILE[0]
6220 PRINT FILE[0],PROG$,PASS$
6223 IF TOTIME=0 THEN GOTO 6240
6225 IF TOTIME>0 THEN GOTO 6230
6227 LET TOTIME=TOTIME+60*60*24
6230 PRINT FILE[0],"EXEC TIME :";TOTIME;" SECS"
6240 PRINT FILE[0]
6250 PRINT FILE[0]
6270 PRINT FILE[0]
6275 STMA 7,5
6280 RETURN 
9000 REM   THIS ROUTINE HANDLES ANY SYSTEM ERRORS ENCOUNTERED
9005 ON ERR THEN GOTO 9999
9007 IF SYS(10)<>1 THEN GOTO 9010
9008 STMA 2,3,1
9009 GOTO 9035
9010 DIM ERRMES$[100],SYSTST$[20]
9015 STMA 9,2,SYSTST$
9020 LET ERRMES$=ERM$(SYS(7))
9030 PRINT FILE[0],"***ERROR";SYS(31);"****   LINE";SYS(20);
9032 PRINT FILE[0],"  OF PROCESS  ";SYSTST$,ERRMES$
9035 LET PASS$="NOT EXECUTED"
9037 LET TOTIME=0
9040 GOTO 9900
9900 GOSUB 6200 :  PRINT TEST-RESULTS
9970 GOTO 9999
9989 END 
9999 END 
