/*************************************************************************
*
*
*	Name:  sdchars.h
*
*	Description:  Include file to define system specific terminal chars.
*
*
*	History:
*	Date		By		Comments
*
*	04/16/84	waf
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright (c) 1983, 1984 by Digital Communication Assoc..
*
*************************************************************************
*  SForm routines module.  */




/*  Notes -

	***> At this time, the PC version assumes that ANSI.SYS is used.
*/

#if		SF_ALTOS

/*********************
**		ALTOS		**
*********************/

/* Fn Key lead char */
#define		FKLEAD	0x1e

/* Fn Key char values */
/* un-shifted Fn Keys */
#define		FK1		0x71
#define		FK2		0x72
#define		FK3		0x73
#define		FK4		0x74
#define		FK5		0x75
#define		FK6		0x76
#define		FK7		0x77
#define		FK8		0x78
/* shifted Fn Keys */
#define		FKS1	0x61
#define		FKS2	0x62
#define		FKS3	0x63
#define		FKS4	0x64
#define		FKS5	0x65
#define		FKS6	0x66
#define		FKS7	0x67
#define		FKS8	0x68

/* Fn Key assignments */
static int	fkary[][2]	= {
/*	FK val	FK fn	*/
	FK1,	SF_NXTFLD,
	FKS1,	SF_PRVFLD,
	FK2,	SF_NXTGRP,
	FKS2,	SF_PRVGRP,
	FK3,	SF_NXTWIN,
	FKS3,	SF_PRVWIN,
	FK4,	SF_NXTENUM,
	FKS4,	SF_PRVENUM,
	FK5,	-1,
	FKS5,	SF_CLRFLD,
	FK6,	-1,
	FKS6,	-1,
	FK7,	-1,
	FKS7,	SF_CLRERR,
	FK8,	SF_FINISH,
	FKS8,	SF_ABORT,
	-1,		-1
	} ;


/* define range of 'good' chars */
/* #define		CHARLO	32 */		/* lower bound */
/* #define		CHARHI	126 */		/* upper bound */

#endif

#if		SF_PC

/*****************
**		PC		**
*****************/

/* Fn Key lead char */
#define		FKLEAD	0

/* Fn Key char values */
/* un-shifted Fn Keys */
#define		FK1		59
#define		FK2		60
#define		FK3		61
#define		FK4		62
#define		FK5		63
#define		FK6		64
#define		FK7		65
#define		FK8		66
/* shifted Fn Keys */
#define		FKS1	84
#define		FKS2	85
#define		FKS3	86
#define		FKS4	87
#define		FKS5	88
#define		FKS6	89
#define		FKS7	90
#define		FKS8	91

/* Fn Key assignments */
static int	fkary[][2]	= {
/*	FK val	FK fn	*/
	FK1,	SF_NXTFLD,
	FKS1,	SF_PRVFLD,
	FK2,	SF_NXTGRP,
	FKS2,	SF_PRVGRP,
	FK3,	SF_NXTWIN,
	FKS3,	SF_PRVWIN,
	FK4,	SF_NXTENUM,
	FKS4,	SF_PRVENUM,
	FK5,	-1,
	FKS5,	SF_CLRFLD,
	FK6,	-1,
	FKS6,	-1,
	FK7,	-1,
	FKS7,	SF_CLRERR,
	FK8,	SF_FINISH,
	FKS8,	SF_ABORT,
	-1,		-1
	} ;


/* define range of 'good' chars */
#define		CHARLO		32	/* lower bound */
#define		CHARHI		126	/* upper bound */


/* Define some chars */
#define		DELCHAR		8	/* Delete (backspace) char */
#define		KILLCHAR	15	/* Kill char (???) */
#define		UNP1		13	/* Unpend */
#define		UNP2		10	/* Another unpend */
#define		INTCHAR		0x1b /* Escape (int) char */
#define		QUITCHAR	3	/* Quit char (???) */

#endif
