/*	** Modified by waf for Altos **	*/


/*                                                              */
/*         Copyright 1984 Digital Communications Assoc.         */
/*                                                              */
/*								*/
/*	 Module: DATA.C						*/
/*								*/
/*	Purpose: global (external) data definitions		*/
/*								*/


#include "DEFINES.H"

/* general purpose flags, etc. */

int	host_level = IDLE;
int	fd = -1;
int	mode = 0;
int	cursor = -1;
int	data_attr = 80, data_start = 81;
int	ctrl_posn = UNDEF;
int	data_end, ctrl_attr;
int	seqno, bmode;
int	c_row, c_col, c_width = 8;
long	rec_count;


/* buffers, pointers, etc. for disk & screen i/o */

int	column, tab_cnt, f_count, f_posn, i_posn, o_posn, busy;
int	i_rpt_count, i_rpt_char , o_rpt_count, o_rpt_char;
char	i_buf[SCREENMAX], o_buf[SCREENMAX];
char	f_buf[FILEMAX];


/* binary mode data items */

long	bchksum;
char	rconv[256], conv[65];


/* keycode strings for ENTER, PF keys, ATTN, CLEAR, etc. for */
/* use in sendkey() (this will make modification easier with */
/* RPQ keyboards, etc), the format is three hex codes and a  */
/* null terminator					     */

/* waf
char	enter[4] = "\x18\x00\x00\x00";
char	clear[4] = "\x4F\x51\xCF\x00";
char	erase[4] = "\x4F\x53\xCF\x00";
waf */


/* 8088 registers for SYSTEM & BIOS10 */

struct	regs REGS;


/* host definitions for data set parameters, etc. */

/* waf
struct	host_def host = {
	"CALL OPUS.LOAD(OPUS)",
	"TACG",
	"SHR",
	TRIG_SECS, NO_X_COUNT, TRUE, FALSE,
	"ASM",      "TAC1AA", "USA", 2, 2, 8, 80,  3120, 73, 8, 0, 1, 0, 0, 1, 3,
	"CLIST",    "TAC1AA", "USA", 2, 2, 8, 255, 3120, 1,  8, 0, 1, 0, 0, 1, 3,
	"CNTL",     "TAC1AA", "USA", 2, 2, 8, 80,  3120, 73, 8, 0, 1, 0, 0, 1, 3,
 	"COBOL",    "TAC1AA", "USA", 2, 2, 8, 80,  3120, 1,  6, 0, 1, 0, 0, 1, 3,
 	"DATA",     "TAC1AA", "USA", 2, 2, 8, 80,  3120, 73, 8, 0, 1, 0, 0, 1, 3,
	"FORTE",    "TAC1AA", "USA", 2, 2, 8, 80,  400,  73, 8, 0, 1, 0, 0, 1, 3,
	"FORTG",    "TAC1AA", "USA", 2, 2, 8, 80,  400,  73, 8, 0, 1, 0, 0, 1, 3,
	"FORTGI",   "TAC1AA", "USA", 2, 2, 8, 80,  3120, 73, 8, 0, 1, 0, 0, 1, 3,
	"FORTH",    "TAC1AA", "USA", 2, 2, 8, 80,  3120, 73, 8, 0, 1, 0, 0, 1, 3,
	"GOFORT",   "TAC1AA", "USA", 2, 2, 8, 255, 3120, 1,  8, 0, 1, 0, 0, 1, 3,
	"PLI",      "TAC1AA", "USA", 2, 2, 8, 104, 3120, 1,  8, 0, 1, 0, 0, 1, 3,
	"PLIF",     "TAC1AA", "USA", 2, 2, 8, 80,  400,  73, 8, 0, 1, 0, 0, 1, 3,
	"TEXT",     "TAC1AA", "USA", 2, 2, 8, 255, 3120, 1,  8, 0, 1, 0, 0, 1, 3,
	"VSBASIC",  "TAC1AA", "USA", 2, 2, 8, 255, 3120, 1,  5, 0, 1, 0, 0, 1, 3,
	"",         "",       "",    0, 0, 0, 0,   0,    0,  0, 0, 0, 0, 0, 0, 0
};
waf */


/* local copies of the transfer parameters for actual transfer  */

char	 x_file_type[9], x_vol_ser[7], x_code_name[9];
int	 x_pri_quan, x_sec_quan, x_dir_blks, x_rec_size;
int	 x_blk_size, x_num_pos, x_num_len;
unsigned x_xfer_mode, x_exp_tabs, x_trunc_spaces, x_space_units;
unsigned x_ul_case, x_rec_fmt;


/* working copies of xfer_table data items are used to reduce	*/
/* the number of structure member accesses required		*/

char	x_lead_in[7];
char	x_extend[13];
char	x_repeat[69];
int	rpt_max;
char	esc_1, esc_2, esc_3, eor;

/*	encode[][] is used to convert from characters to	*/
/*	buffer codes for copying to IRMA and decode reverses	*/
/*	the process, both are constructed at run time.		*/

int	decode[4][256];
int	encode[256][2];


/* transfer table for standard (safe) configuration		*/

struct	xfer_table x_table = {
	/* ---------------- dup flags -------------- */
	FALSE, FALSE,
	/* ----------------- lead_in --------------- */
	0x10, 0x09, 0x08, 0x30, 0x0D, 0x0C, 0x00,
	/* ----------------- extend ---------------- */
	0x11, 0xBF, 0x35, 0x31, 0x14, 0x34, 0x2E, 0xBE,
	0x2F, 0x18, 0x12, 0x00,
	/* ------------ binary & repeat ------------ */
	0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,
	0x28, 0x29, 0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5,
	0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD,
	0xAE, 0xAF, 0xB0, 0xB1, 0xB2, 0xB3, 0xB4, 0xB5,
	0xB6, 0xB7, 0xB8, 0xB9, 0x80, 0x81, 0x82, 0x83,
	0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B,
	0x8C, 0x8D, 0x8E, 0x8F, 0x90, 0x91, 0x92, 0x93,
	0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x33, 0x32,
	0x00,
	/* ---------------- translate -------------- */
	0x00,    0x00,    0x01,    0x19,
	0x01,    0x01,    0x01,    0x2C,
	0x02,    0x02,    0x01,    0x1A,
	0x03,    0x03,    0x01,    0x2E,
	0x04,    0x37,    0x01,    0x0D,
	0x05,    0x2D,    0x01,    0x0C,
	0x06,    0x2E,    0x01,    0xBF,
	0x07,    0x2F,    0x01,    0x35,
	0x08,    0x16,    0x01,    0x33,
	0x09,    0x05,    0x01,    0x31,
	0x0A,    0x25,    0x01,    0x32,
	0x0B,    0x0B,    0x01,    0x14,
	0x0C,    0x0C,    0x01,    0x20,
	0x0D,    0x0D,    0x01,    0x21,
	0x0E,    0x0E,    0x01,    0x22,
	0x0F,    0x0F,    0x01,    0x23,
	0x10,    0x10,    0x01,    0x24,
	0x11,    0x11,    0x01,    0x25,
	0x12,    0x12,    0x01,    0x26,
	0x13,    0x13,    0x01,    0x27,
	0x14,    0x3C,    0x01,    0x28,
	0x15,    0x3D,    0x01,    0x29,
	0x16,    0x32,    0x01,    0x34,
	0x17,    0x26,    0x01,    0x09,
	0x18,    0x18,    0x01,    0x11,
	0x19,    0x19,    0x01,    0x08,
	0x1A,    0x3F,    0x01,    0x18,
	0x1B,    0x27,    0x01,    0x2D,
	0x1C,    0x1C,    0x01,    0xA0,
	0x1D,    0x1D,    0x01,    0xA1,
	0x1E,    0x1E,    0x01,    0xA2,
	0x1F,    0x1F,    0x01,    0xA3,
	0x20,    0x40,    0x00,    0x10,
	0x21,    0x5A,    0x00,    0x19,
	0x22,    0x7F,    0x00,    0x13,
	0x23,    0x7B,    0x00,    0x2C,
	0x24,    0x5B,    0x00,    0x1A,
	0x25,    0x6C,    0x00,    0x2E,
	0x26,    0x50,    0x03,    0x30,
	0x27,    0x7D,    0x00,    0x12,
	0x28,    0x4D,    0x00,    0x0D,
	0x29,    0x5D,    0x00,    0x0C,
	0x2A,    0x5C,    0x00,    0xBF,
	0x2B,    0x4E,    0x00,    0x35,
	0x2C,    0x6B,    0x00,    0x33,
	0x2D,    0x60,    0x00,    0x31,
	0x2E,    0x4B,    0x00,    0x32,
	0x2F,    0x61,    0x00,    0x14,
	0x30,    0xF0,    0x00,    0x20,
	0x31,    0xF1,    0x00,    0x21,
	0x32,    0xF2,    0x00,    0x22,
	0x33,    0xF3,    0x00,    0x23,
	0x34,    0xF4,    0x00,    0x24,
	0x35,    0xF5,    0x00,    0x25,
	0x36,    0xF6,    0x00,    0x26,
	0x37,    0xF7,    0x00,    0x27,
	0x38,    0xF8,    0x00,    0x28,
	0x39,    0xF9,    0x00,    0x29,
	0x3A,    0x7A,    0x03,    0x34,
	0x3B,    0x5E,    0x00,    0xBE,
	0x3C,    0x4C,    0x03,    0x09,
	0x3D,    0x7E,    0x00,    0x11,
	0x3E,    0x6E,    0x03,    0x08,
	0x3F,    0x6F,    0x00,    0x18,
	0x40,    0x7C,    0x00,    0x2D,
	0x41,    0xC1,    0x00,    0xA0,
	0x42,    0xC2,    0x00,    0xA1,
	0x43,    0xC3,    0x00,    0xA2,
	0x44,    0xC4,    0x00,    0xA3,
	0x45,    0xC5,    0x00,    0xA4,
	0x46,    0xC6,    0x00,    0xA5,
	0x47,    0xC7,    0x00,    0xA6,
	0x48,    0xC8,    0x00,    0xA7,
	0x49,    0xC9,    0x00,    0xA8,
	0x4A,    0xD1,    0x00,    0xA9,
	0x4B,    0xD2,    0x00,    0xAA,
	0x4C,    0xD3,    0x00,    0xAB,
	0x4D,    0xD4,    0x00,    0xAC,
	0x4E,    0xD5,    0x00,    0xAD,
	0x4F,    0xD6,    0x00,    0xAE,
	0x50,    0xD7,    0x00,    0xAF,
	0x51,    0xD8,    0x00,    0xB0,
	0x52,    0xD9,    0x00,    0xB1,
	0x53,    0xE2,    0x00,    0xB2,
	0x54,    0xE3,    0x00,    0xB3,
	0x55,    0xE4,    0x00,    0xB4,
	0x56,    0xE5,    0x00,    0xB5,
	0x57,    0xE6,    0x00,    0xB6,
	0x58,    0xE7,    0x00,    0xB7,
	0x59,    0xE8,    0x00,    0xB8,
	0x5A,    0xE9,    0x00,    0xB9,
	0x5B,    0x4A,    0x00,    0x1B,
	0x5C,    0xE0,    0x00,    0x15,
	0x5D,    0x4F,    0x00,    0x16,
	0x5E,    0x5F,    0x00,    0x36,
	0x5F,    0x6D,    0x00,    0x2F,
	0x60,    0x79,    0x00,    0x3D,
	0x61,    0x81,    0x00,    0x80,
	0x62,    0x82,    0x00,    0x81,
	0x63,    0x83,    0x00,    0x82,
	0x64,    0x84,    0x00,    0x83,
	0x65,    0x85,    0x00,    0x84,
	0x66,    0x86,    0x00,    0x85,
	0x67,    0x87,    0x00,    0x86,
	0x68,    0x88,    0x00,    0x87,
	0x69,    0x89,    0x00,    0x88,
	0x6A,    0x91,    0x00,    0x89,
	0x6B,    0x92,    0x00,    0x8A,
	0x6C,    0x93,    0x00,    0x8B,
	0x6D,    0x94,    0x00,    0x8C,
	0x6E,    0x95,    0x00,    0x8D,
	0x6F,    0x96,    0x00,    0x8E,
	0x70,    0x97,    0x00,    0x8F,
	0x71,    0x98,    0x00,    0x90,
	0x72,    0x99,    0x00,    0x91,
	0x73,    0xA2,    0x00,    0x92,
	0x74,    0xA3,    0x00,    0x93,
	0x75,    0xA4,    0x00,    0x94,
	0x76,    0xA5,    0x00,    0x95,
	0x77,    0xA6,    0x00,    0x96,
	0x78,    0xA7,    0x00,    0x97,
	0x79,    0xA8,    0x00,    0x98,
	0x7A,    0xA9,    0x00,    0x99,
	0x7B,    0xC0,    0x01,    0xA4,
	0x7C,    0x6A,    0x00,    0x17,
	0x7D,    0xD0,    0x01,    0xA5,
	0x7E,    0xA1,    0x01,    0xA6,
	0x7F,    0x07,    0x01,    0xA7,
	0x80,    0x20,    0x01,    0xA8,
	0x81,    0x21,    0x01,    0xA9,
	0x82,    0x22,    0x01,    0xAA,
	0x83,    0x23,    0x01,    0xAB,
	0x84,    0x24,    0x01,    0xAC,
	0x85,    0x15,    0x01,    0xAD,
	0x86,    0x06,    0x01,    0xAE,
	0x87,    0x17,    0x01,    0xAF,
	0x88,    0x28,    0x01,    0xB0,
	0x89,    0x29,    0x01,    0xB1,
	0x8A,    0x2A,    0x01,    0xB2,
	0x8B,    0x2B,    0x01,    0xB3,
	0x8C,    0x2C,    0x01,    0xB4,
	0x8D,    0x09,    0x01,    0xB5,
	0x8E,    0x0A,    0x01,    0xB6,
	0x8F,    0x1B,    0x01,    0xB7,
	0x90,    0x30,    0x01,    0xB8,
	0x91,    0x31,    0x01,    0xB9,
	0x92,    0x1A,    0x01,    0x15,
	0x93,    0x33,    0x01,    0x2F,
	0x94,    0x34,    0x01,    0x80,
	0x95,    0x35,    0x01,    0x81,
	0x96,    0x36,    0x01,    0x82,
	0x97,    0x08,    0x01,    0x83,
	0x98,    0x38,    0x01,    0x84,
	0x99,    0x39,    0x01,    0x85,
	0x9A,    0x3A,    0x01,    0x86,
	0x9B,    0x3B,    0x01,    0x87,
	0x9C,    0x04,    0x01,    0x88,
	0x9D,    0x14,    0x01,    0x89,
	0x9E,    0x3E,    0x01,    0x8A,
	0x9F,    0xE1,    0x01,    0x8B,
	0xA0,    0x41,    0x01,    0x8C,
	0xA1,    0x42,    0x01,    0x8D,
	0xA2,    0x43,    0x01,    0x8E,
	0xA3,    0x44,    0x01,    0x8F,
	0xA4,    0x45,    0x01,    0x90,
	0xA5,    0x46,    0x01,    0x91,
	0xA6,    0x47,    0x01,    0x92,
	0xA7,    0x48,    0x01,    0x93,
	0xA8,    0x49,    0x01,    0x94,
	0xA9,    0x51,    0x01,    0x95,
	0xAA,    0x52,    0x01,    0x96,
	0xAB,    0x53,    0x01,    0x97,
	0xAC,    0x54,    0x01,    0x98,
	0xAD,    0x55,    0x01,    0x99,
	0xAE,    0x56,    0x02,    0x19,
	0xAF,    0x57,    0x02,    0x2C,
	0xB0,    0x58,    0x02,    0x1A,
	0xB1,    0x59,    0x02,    0x2E,
	0xB2,    0x62,    0x02,    0x0D,
	0xB3,    0x63,    0x02,    0x0C,
	0xB4,    0x64,    0x02,    0xBF,
	0xB5,    0x65,    0x02,    0x35,
	0xB6,    0x66,    0x02,    0x33,
	0xB7,    0x67,    0x02,    0x31,
	0xB8,    0x68,    0x02,    0x32,
	0xB9,    0x69,    0x02,    0x14,
	0xBA,    0x70,    0x02,    0x20,
	0xBB,    0x71,    0x02,    0x21,
	0xBC,    0x72,    0x02,    0x22,
	0xBD,    0x73,    0x02,    0x23,
	0xBE,    0x74,    0x02,    0x24,
	0xBF,    0x75,    0x02,    0x25,
	0xC0,    0x76,    0x02,    0x26,
	0xC1,    0x77,    0x02,    0x27,
	0xC2,    0x78,    0x02,    0x28,
	0xC3,    0x80,    0x02,    0x29,
	0xC4,    0x8A,    0x02,    0x34,
	0xC5,    0x8B,    0x02,    0x09,
	0xC6,    0x8C,    0x02,    0x11,
	0xC7,    0x8D,    0x02,    0x08,
	0xC8,    0x8E,    0x02,    0x18,
	0xC9,    0x8F,    0x02,    0x2D,
	0xCA,    0x90,    0x02,    0xA0,
	0xCB,    0x9A,    0x02,    0xA1,
	0xCC,    0x9B,    0x02,    0xA2,
	0xCD,    0x9C,    0x02,    0xA3,
	0xCE,    0x9D,    0x02,    0xA4,
	0xCF,    0x9E,    0x02,    0xA5,
	0xD0,    0x9F,    0x02,    0xA6,
	0xD1,    0xA0,    0x02,    0xA7,
	0xD2,    0xAA,    0x02,    0xA8,
	0xD3,    0xAB,    0x02,    0xA9,
	0xD4,    0xAC,    0x02,    0xAA,
	0xD5,    0xAD,    0x02,    0xAB,
	0xD6,    0xAE,    0x02,    0xAC,
	0xD7,    0xAF,    0x02,    0xAD,
	0xD8,    0xB0,    0x02,    0xAE,
	0xD9,    0xB1,    0x02,    0xAF,
	0xDA,    0xB2,    0x02,    0xB0,
	0xDB,    0xB3,    0x02,    0xB1,
	0xDC,    0xB4,    0x02,    0xB2,
	0xDD,    0xB5,    0x02,    0xB3,
	0xDE,    0xB6,    0x02,    0xB4,
	0xDF,    0xB7,    0x02,    0xB5,
	0xE0,    0xB8,    0x02,    0xB6,
	0xE1,    0xB9,    0x02,    0xB7,
	0xE2,    0xBA,    0x02,    0xB8,
	0xE3,    0xBB,    0x02,    0xB9,
	0xE4,    0xBC,    0x02,    0x15,
	0xE5,    0xBD,    0x02,    0x2F,
	0xE6,    0xBE,    0x02,    0x80,
	0xE7,    0xBF,    0x02,    0x81,
	0xE8,    0xCA,    0x02,    0x82,
	0xE9,    0xCB,    0x02,    0x83,
	0xEA,    0xCC,    0x02,    0x84,
	0xEB,    0xCD,    0x02,    0x85,
	0xEC,    0xCE,    0x02,    0x86,
	0xED,    0xCF,    0x02,    0x87,
	0xEE,    0xDA,    0x02,    0x88,
	0xEF,    0xDB,    0x02,    0x89,
	0xF0,    0xDC,    0x02,    0x8A,
	0xF1,    0xDD,    0x02,    0x8B,
	0xF2,    0xDE,    0x02,    0x8C,
	0xF3,    0xDF,    0x02,    0x8D,
	0xF4,    0xEA,    0x02,    0x8E,
	0xF5,    0xEB,    0x02,    0x8F,
	0xF6,    0xEC,    0x02,    0x90,
	0xF7,    0xED,    0x02,    0x91,
	0xF8,    0xEE,    0x02,    0x92,
	0xF9,    0xEF,    0x02,    0x93,
	0xFA,    0xFA,    0x02,    0x94,
	0xFB,    0xFB,    0x02,    0x95,
	0xFC,    0xFC,    0x02,    0x96,
	0xFD,    0xFD,    0x02,    0x97,
	0xFE,    0xFE,    0x02,    0x98,
	0xFF,    0xFF,    0x02,    0x99
};

/*		        end of DATA.C     			*/
