/*************************************************************************
*
*
*	Name:  strio.c
*
*	Description:  String field i/o.
*
*
*	History:
*	Date		By		Comments
*
*	03/16/84	waf
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright (c) 1983, 1984 by Digital Communication Assoc..
*
*************************************************************************
*  SForm routines module.  */




/*  Notes -

*/

#include	"/sform/src/sfint.h"

extern int	sfstrinp(), sfstrdisp() ;
extern char	*malloc() ;




sfstrio ( fld_desc, mode, data_ptr )

struct SF_FIELD *fld_desc ;
int		mode ;
char	*data_ptr ;

/*
  Synopsis -
	String field i/o function.

  Description -
	$

  Return -
	return val	= Completion code or Fn Key value -
				Valid completion codes are
				SF_ERROR	= non-recoverable error during data entry.
				SF_EDPROT	= tried to update a protected field.
				Valid Fn Key return values are
				SF_NXTFLD,SF_PRVFLD
				SF_NXTGRP,SF_PRVGRP
				SF_NXTWIN,SF_PRVWIN
				SF_ABORT
				SF_FINISH

  Notes -
*/

{
	register int fc ;		/* return code from input fn */
	register int fwid ;
	
	    /* Do field i/o */
	fwid = fld_desc->sf_width ;		/* binary size = field width */
	fc = sfgenio(fld_desc, mode, data_ptr, fwid, sfstrinp, sfstrdisp ) ;

	/* return the completion code */
	return(fc) ;
}
