/*                                                           */
/*       Copyright 1983 Technical Analysis Corporation       */
/*                                                           */

#include <stdio.h>


/* global constants */

#define EOL '\n'
#define RET '\r'
#define NUL '\0'


/* communications modes */

#define ACK 'A'
#define CONTROL 'C'
#define DATA 'D'
#define NAK 'N'
#define POLL 'P'
#define SYNC 'S'
#define QUIT 'Q'
#define QUESTION_MARK '?'


/* data transfer formats */

#define TEXT 'T'
#define BINARY 'B'
#define PROGRAM 'P'


/* commands & control codes */

#define WRITE 'W'
#define READ 'R'
#define ERROR 'E'
#define LOG 'L'
#define COMMENT 'C'
#define BYE 'B'


/* external (global) data items */

extern int master, seq;
extern int nrtys, timeout;
extern int tos, cksums,seqs, naks, bads;
extern int wc, rc, cc, lc;
extern FILE *wp, *rp, *cp, *lp, *fopen();
extern int commin, commout;


#ifdef debug  			     /* define PSIZE based on DEBUG */
#define PSIZE 30
#else
#define PSIZE 120
#endif

