/* fp 	- file print utility.

Usage:	fp [-sw] <file>

Switches -
	d/o/x	- display in decimal/octal/hex.
	f		- full display (show all data).


10/19/83	waf	Added switches.
*/

#include <stdio.h>

main(argc, argv)
int argc;
char *argv[];
{
	int c, a, i, j, dupline = 0;
	char addr[5], hex[49], thex[49], ascii[17], *infil, *fopen();
	int	base;		/* display base */
	int	fullsw;		/* f switch */

	if (argc < 2) {
		printf("Usage: fp file\n");
		exit(-1);
		}

	/* get switches */
	fullsw = 0 ;

	if ((infil = fopen(*++argv, "r")) == NULL) {
		printf("fp: can't open %s\n", *argv);
		exit(-2);
		}
	c = getc(infil);
	a = 0;
	while (c != EOF) {
		itohex(addr, a, 4);
		a += 16;
		for (i = 0; i < 16; i++)
			ascii[i] = ' ';
		ascii[16] = '\0';
		for (i = 0; i < 48; i++)
			hex[i] = ' ';
		hex[48] = '\0';
		for (i = 0, j= 0; i < 16; i++)
			if (c != EOF) {
				hex[j++] =  hexdigit(c>>4);
				hex[j++] =  hexdigit(c);
				hex[j++] =  ' ';
				if (c >= 32 && c <= 127)
					ascii[i] = c;
				else
					ascii[i] = '.';
				c = getc(infil);
				}
		if (strcmp(hex, thex) == 0)
			dupline = 1;
		else {
			if (dupline != 0)
				printf("***\n");
			dupline = 0;
			printf("   %s: %s   %s \n", addr, hex, ascii);
			}
		strcpy(thex, hex);
		}
	if (dupline != 0)
		printf("***\n");
	} /* end-main */

char hexdigit(x)
int x;
{
	return( ((x&15) <= 9) ? ((x & 15) + '0') : (((x & 15) - 10) + 'A') );
	} /* end-hexdigit */

itohex(outstr, inpval, prec)
char outstr[];
int inpval, prec;
{
	int i;
	outstr[prec] = '\0';
	for (i = prec - 1; i >= 0; inpval >>= 4, i--)
		outstr[i] = hexdigit(inpval);
	} /* end-itohex */

