/*************************************************************************
*
*
*	Name:  prtbaud.c
*
*	Description:  Set printer baud rate.
*
*
*	History:
*	Date		By		Comments
*
*	02/24/84	waf
*
*
*
*  This document contains confidential/proprietary information.
*
*  Copyright (c) 1983, 1984 by D.C.A.
*
*************************************************************************/




/*  Notes -

  Changing the baud rate of the printer to some value other than the default
(9600 baud) is not well supported on the 8600. The 'stty' cmd will not affect
a port unless the port is 'active', and the entry in '/etc/ttys' must be set
to '0' to prevent the 'login' message and strange control chars from being
output every time the printer is used.

  This pgm changes the printer port baud rate by opening the port (/dev/tty7),
changing the baud rate with 'stty', then permanently going to sleep. Note that
this process must always be present, otherwise the baud rate gets reset to the
default value.

  It is suggested that '/etc/rc' invoke this pgm.

*/


#include	<sgtty.h>

#define		PRTPORT		"/dev/tty8"		/* printer port name */
#define		BAUDRATE	B4800			/* new baud rate */



main()
{
	struct	sgttyb	argp ;
	int		fd ;



	/* set new baud rate */
	ioctl(0, TIOCGETP, &argp) ;

	ioctl(fd, TIOCSETP, &argp) ;

	/* go to sleep (forever) */
	for (;;)
		pause() ;

	}
